missing.h File Reference
`#include "ruby/config.h"`
`#include <stddef.h>`

Go to the source code of this file.

## Data Structures

struct | timeval
struct | timespec
struct | timezone

## Macros

#define | time_t long
#define | RUBY_EXTERN extern
#define | INFINITY (*(float *)rb_infinity)
#define | NAN (*(float *)rb_nan)

## Functions

RUBY_EXTERN double | acosh (double)
RUBY_EXTERN double | asinh (double)
RUBY_EXTERN double | atanh (double)
RUBY_EXTERN char * | crypt (const char *, const char *)
RUBY_EXTERN int | dup2 (int, int)
RUBY_EXTERN int | eaccess (const char *, int)
RUBY_EXTERN double | round (double)
RUBY_EXTERN int | finite (double)
RUBY_EXTERN int | flock (int, int)
RUBY_EXTERN double | hypot (double, double)
RUBY_EXTERN double | erf (double)
RUBY_EXTERN double | erfc (double)
RUBY_EXTERN double | tgamma (double)
RUBY_EXTERN double | lgamma_r (double, int *)
RUBY_EXTERN double | cbrt (double)
RUBY_EXTERN int | isinf (double)
RUBY_EXTERN int | isnan (double)
RUBY_EXTERN void * | memmove (void *, const void *, size_t)
RUBY_EXTERN char * | strchr (const char *, int)
RUBY_EXTERN char * | strrchr (const char *, int)
RUBY_EXTERN char * | strerror (int)
RUBY_EXTERN char * | strstr (const char *, const char *)
RUBY_EXTERN size_t | strlcpy (char *, const char *, size_t)
RUBY_EXTERN size_t | strlcat (char *, const char *, size_t)
RUBY_EXTERN int | signbit (double x)
RUBY_EXTERN int | ffs (int)
RUBY_EXTERN void | setproctitle (const char *fmt,...)

## Variables

RUBY_EXTERN const unsigned char | rb_infinity []
RUBY_EXTERN const unsigned char | rb_nan []

## Macro Definition Documentation

#define INFINITY (*(float *)rb_infinity)

Definition at line 132 of file missing.h.

Referenced by big_fdiv(), fix_pow(), Init_date_core(), Init_Numeric(), math_atanh(), math_lgamma(), math_log(), math_log10(), math_log2(), and r_object0().

#define NAN (*(float *)rb_nan)

Definition at line 140 of file missing.h.

Referenced by Init_Numeric(), nurat_div(), and r_object0().

#define RUBY_EXTERN extern

Definition at line 63 of file missing.h.

#define time_t long

Definition at line 30 of file missing.h.

Referenced by date_s_today(), datetime_s_now(), filetime_to_unixtime(), fill_random_seed(), find_time_t(), gmtimew(), guess_local_offset(), init_leap_second_info(), localtimew(), main(), mktime_do(), obj_to_asn1gtime(), obj_to_asn1utime(), ossl_ssl_session_get_time(), ossl_ssl_session_get_timeout(), ossl_sslctx_flush_sessions(), ossl_x509_set_not_after(), ossl_x509_set_not_before(), ossl_x509crl_set_last_update(), ossl_x509crl_set_next_update(), ossl_x509revoked_set_time(), rb_f_sleep(), rb_gmtime_r2(), rb_gzfile_mtime(), rb_localtime_r2(), rb_mutex_sleep(), rb_strftime_with_timespec(), time_mload(), time_overflow_p(), time_timespec(), time_to_time_t(), timegm_noleapsecond(), timegmw(), timelocalw(), and wv2timet().

## Function Documentation

RUBY_EXTERN double acosh | ( | double |  | ) |

Definition at line 36 of file acosh.c.

References BIG_CRITERIA.

Referenced by math_acosh().

RUBY_EXTERN double asinh | ( | double |  | ) |

Definition at line 52 of file acosh.c.

References BIG_CRITERIA, DBL_MANT_DIG, neg, and SMALL_CRITERIA.

Referenced by math_asinh().

RUBY_EXTERN double atanh | ( | double |  | ) |

Definition at line 75 of file acosh.c.

References errno, isinf(), neg, and SMALL_CRITERIA.

Referenced by math_atanh().

RUBY_EXTERN double cbrt | ( | double |  | ) |

Definition at line 4 of file cbrt.c.

Referenced by math_cbrt().

RUBY_EXTERN char* crypt | ( | const char * | ,
|  | const char * |
| ) |  |

Definition at line 500 of file crypt.c.

References _PASSWORD_EFMT1, a64toi, C_block::b, constdatablock, cryptresult, des_cipher(), des_setkey(), i, itoa64, long, and NULL.

Referenced by rb_str_crypt().

RUBY_EXTERN int dup2 | ( | int | ,
|  | int |
| ) |  |

Definition at line 27 of file dup2.c.

References BADEXIT, errno, fcntl(), and i.

Referenced by chfunc(), fill_standard_fds(), io_reopen(), and main().

RUBY_EXTERN int eaccess | ( | const char * | ,
|  | int |
| ) |  |

Definition at line 1029 of file file.c.

References access, geteuid(), rb_group_member(), S_IXUGO, STAT, stat, and X_OK.

Referenced by dln_find_1(), rb_file_executable_p(), rb_file_readable_p(), and rb_file_writable_p().

RUBY_EXTERN double erf | ( | double |  | ) |

Definition at line 71 of file erf.c.

References finite(), isnan, LOG_PI_OVER_2, and p_gamma().

Referenced by math_erf().

RUBY_EXTERN double erfc | ( | double |  | ) |

Definition at line 81 of file erf.c.

References finite(), isnan, LOG_PI_OVER_2, p_gamma(), and q_gamma().

Referenced by math_erfc().

RUBY_EXTERN int ffs | ( | int |  | ) |

Definition at line 6 of file ffs.c.

RUBY_EXTERN int finite | ( | double |  | ) |

Definition at line 6 of file finite.c.

References isinf(), and isnan.

Referenced by erf(), erfc(), and flo_is_finite_p().

RUBY_EXTERN int flock | ( | int | ,
|  | int |
| ) |  |

Definition at line 124 of file flock.c.

RUBY_EXTERN double hypot | ( | double | ,
|  | double |
| ) |  |

Definition at line 6 of file hypot.c.

Referenced by math_hypot().

RUBY_EXTERN int isinf | ( | double |  | ) |

Definition at line 56 of file isinf.c.

References inf(), and memcmp().

Referenced by atanh(), big_op(), BigMath_s_exp(), BigMath_s_log(), BSD_vfprintf(), c_valid_start_p(), c_virtual_sg(), dbl2big(), finite(), flo_cmp(), flo_is_finite_p(), flo_is_infinite_p(), flo_round(), flo_to_s(), float_denominator(), float_numerator(), float_value(), flodivmod(), guess_style(), m_julian_p(), m_proleptic_gregorian_p(), m_proleptic_julian_p(), math_atan2(), math_gamma(), math_lgamma(), nurat_div(), rand_range(), rb_big2dbl(), rb_big_cmp(), rb_big_eq(), rb_big_fdiv(), rb_str_format(), ruby_float_step(), ruby_hdtoa(), s_virtual_sg(), VpDtoV(), and w_float().

RUBY_EXTERN int isnan | ( | double |  | ) |

Definition at line 8 of file isnan.c.

References double_ne().

RUBY_EXTERN double lgamma_r | ( | double | ,
|  | int * |
| ) |  |

Definition at line 63 of file lgamma_r.c.

References errno, i, LOG_PI, loggamma(), and PI.

Referenced by math_lgamma().

RUBY_EXTERN void* memmove | ( | void * | ,
|  | const void * | ,
|  | size_t |
| ) |  |

Definition at line 7 of file memmove.c.

Referenced by BigDecimal_split(), delpair(), extract_fd(), fill_cbuf(), flo_to_s(), io_shift_cbuf(), rb_ary_sample(), rb_str_drop_bytes(), rb_str_lstrip_bang(), rb_str_splice_0(), rb_str_sub_bang(), rb_str_succ(), rb_w32_fdclr(), rb_w32_strerror(), remove_backslashes(), st_delete(), st_foreach(), strio_ungetbyte(), strio_write(), stub_sysinit(), syck_str_blow_away_commas(), sym_inspect(), VpFormatSt(), VpNmlz(), zstream_buffer_ungetbyte(), zstream_buffer_ungets(), zstream_discard_input(), and zstream_shift_buffer().

RUBY_EXTERN double round | ( | double |  | ) |

Definition at line 83 of file numeric.c.

Referenced by BigDecimal_power(), d_lite_plus(), dbl2ival(), fix_pow(), flo_pow(), flo_round(), offset_to_sec(), rb_big_pow(), and wholenum_p().

RUBY_EXTERN void setproctitle | ( | const char * | fmt,
|  |  | ...
| ) |  |

Definition at line 125 of file setproctitle.c.

References len, NULL, SPT_PADCHAR, strlcpy(), strlen(), and vsnprintf.

Referenced by set_arg0().

RUBY_EXTERN int signbit | ( | double | x | ) |

Definition at line 5 of file signbit.c.

References CHAR_BIT, i, and long.

Referenced by f_signbit(), math_atan2(), math_gamma(), and math_lgamma().

RUBY_EXTERN char* strchr | ( | const char * | ,
|  | int |
| ) |  |

Definition at line 8 of file strchr.c.

References strlen().

RUBY_EXTERN char* strerror | ( | int |  | ) |

Definition at line 11 of file strerror.c.

References msg, and sys_errlist.

Referenced by argf_next_argv(), dln_load(), dln_strerror(), inspect_errno(), ossl_pkey_new_from_file(), ossl_x509_new_from_file(), rb_bug_errno(), rb_load_fail(), rb_sys_warning(), rb_w32_strerror(), sys_warning_1(), and syserr_initialize().

RUBY_EXTERN size_t strlcat | ( | char * | ,
|  | const char * | ,
|  | size_t |
| ) |  |

Definition at line 46 of file strlcat.c.

References strlen().

Referenced by dln_load(), file_expand_path(), join_path(), and rb_w32_aspawn_flags().

RUBY_EXTERN size_t strlcpy | ( | char * | ,
|  | const char * | ,
|  | size_t |
| ) |  |

Definition at line 44 of file strlcpy.c.

Referenced by cmdglob(), date_strftime_with_tmx(), dln_find_1(), dln_load(), get_device_once(), rb_feature_p(), rb_strftime_with_timespec(), rb_w32_aspawn_flags(), rb_w32_cmdvector(), rb_w32_strerror(), ruby_brace_expand(), ruby_init_loadpath_safe(), and setproctitle().

RUBY_EXTERN char* strrchr | ( | const char * | ,
|  | int |
| ) |  |

Definition at line 20 of file strchr.c.

References strlen().

RUBY_EXTERN char* strstr | ( | const char * | ,
|  | const char * |
| ) |  |

Definition at line 8 of file strstr.c.

References strlen().

Referenced by do_spawn(), load_file_internal(), and syck_tagcmp().

RUBY_EXTERN double tgamma | ( | double |  | ) |

Definition at line 72 of file tgamma.c.

References errno, i, loggamma(), PI, and zero().

Referenced by math_gamma().

## Variable Documentation

RUBY_EXTERN const unsigned char rb_infinity[]

Definition at line 131 of file missing.h.

RUBY_EXTERN const unsigned char rb_nan[]

Definition at line 139 of file missing.h.